diff --git a/rats-tls/comp.sh b/rats-tls/comp.sh
new file mode 100755
index 000000000..cfd8b822d
--- /dev/null
+++ b/rats-tls/comp.sh
@@ -0,0 +1,3 @@
+make -C build clean
+make -C build
+make -C build install
diff --git a/rats-tls/src/include/rats-tls/api.h b/rats-tls/src/include/rats-tls/api.h
index 37d1ec099..8af11c92c 100644
--- a/rats-tls/src/include/rats-tls/api.h
+++ b/rats-tls/src/include/rats-tls/api.h
@@ -11,6 +11,7 @@
 #include <stdint.h>
 #include <stddef.h>
 #include <rats-tls/err.h>
+#include <openssl/opensslv.h>
 
 #define TLS_TYPE_NAME_SIZE		32
 #define ENCLAVE_ATTESTER_TYPE_NAME_SIZE 32
@@ -36,7 +37,11 @@ typedef enum {
 	RATS_TLS_CERT_ALGO_RSA_3072_SHA256,
 	RATS_TLS_CERT_ALGO_ECC_256_SHA256,
 	RATS_TLS_CERT_ALGO_MAX,
+#if !defined(OPENSSL_VERSION_NUMBER) || OPENSSL_VERSION_NUMBER < 0x10100000L
+	RATS_TLS_CERT_ALGO_DEFAULT = RATS_TLS_CERT_ALGO_RSA_3072_SHA256
+#else
 	RATS_TLS_CERT_ALGO_DEFAULT = RATS_TLS_CERT_ALGO_ECC_256_SHA256
+#endif
 } rats_tls_cert_algo_t;
 
 typedef struct {
diff --git a/rats-tls/src/tls_wrappers/openssl/CMakeLists.txt b/rats-tls/src/tls_wrappers/openssl/CMakeLists.txt
index d2e704244..358076cad 100644
--- a/rats-tls/src/tls_wrappers/openssl/CMakeLists.txt
+++ b/rats-tls/src/tls_wrappers/openssl/CMakeLists.txt
@@ -35,6 +35,7 @@ set(SOURCES cleanup.c
             use_cert.c
             use_privkey.c
             per_thread.c
+            x509_openssl10x.c
             )
 
 # Generate library
diff --git a/rats-tls/src/tls_wrappers/openssl/init.c b/rats-tls/src/tls_wrappers/openssl/init.c
index fcebe533e..fee56ac36 100644
--- a/rats-tls/src/tls_wrappers/openssl/init.c
+++ b/rats-tls/src/tls_wrappers/openssl/init.c
@@ -18,6 +18,8 @@ tls_wrapper_err_t openssl_tls_init(tls_wrapper_ctx_t *ctx)
 
 	OpenSSL_add_all_algorithms();
 	SSL_load_error_strings();
+	ERR_load_crypto_strings();
+	OpenSSL_add_all_ciphers();
 
 	if (SSL_library_init() < 0) {
 		RTLS_ERR("failed to initialize the openssl library\n");
@@ -28,10 +30,20 @@ tls_wrapper_err_t openssl_tls_init(tls_wrapper_ctx_t *ctx)
 	if (!ssl_ctx)
 		return -TLS_WRAPPER_ERR_NO_MEM;
 
-	if (ctx->conf_flags & RATS_TLS_CONF_FLAGS_SERVER)
-		ssl_ctx->sctx = SSL_CTX_new(TLS_server_method());
-	else
-		ssl_ctx->sctx = SSL_CTX_new(TLS_client_method());
+        if (ctx->conf_flags & RATS_TLS_CONF_FLAGS_SERVER) {
+#if !defined(OPENSSL_VERSION_NUMBER) || OPENSSL_VERSION_NUMBER < 0x10100000L
+                ssl_ctx->sctx = SSL_CTX_new(TLSv1_server_method());
+#else
+                ssl_ctx->sctx = SSL_CTX_new(TLS_server_method());
+#endif
+	}
+        else {
+#if !defined(OPENSSL_VERSION_NUMBER) || OPENSSL_VERSION_NUMBER < 0x10100000L
+                ssl_ctx->sctx = SSL_CTX_new(TLSv1_client_method());
+#else
+                ssl_ctx->sctx = SSL_CTX_new(TLS_client_method());
+#endif
+        }
 
 	if (!ssl_ctx->sctx) {
 		free(ssl_ctx);
diff --git a/rats-tls/src/tls_wrappers/openssl/openssl.h b/rats-tls/src/tls_wrappers/openssl/openssl.h
index 72e2a0fe6..39916964f 100644
--- a/rats-tls/src/tls_wrappers/openssl/openssl.h
+++ b/rats-tls/src/tls_wrappers/openssl/openssl.h
@@ -22,6 +22,7 @@
 #include <openssl/rand.h>
 #include <openssl/objects.h>
 #include <openssl/ec.h>
+#include <openssl/opensslv.h>
 
 #define SSL_SUCCESS 1
 
@@ -40,4 +41,8 @@ static inline void print_openssl_err(SSL *ssl, int ret)
 
 	RTLS_DEBUG("%s (err = %d)\n", buf, err);
 }
+
+#if !defined(OPENSSL_VERSION_NUMBER) || OPENSSL_VERSION_NUMBER < 0x10100000L
+extern int X509_STORE_get_ex_new_index(long argl, void *argp, CRYPTO_EX_new *new_func, CRYPTO_EX_dup *dup_func, CRYPTO_EX_free *free_func);
+#endif
 #endif
diff --git a/rats-tls/src/tls_wrappers/openssl/un_negotiate.c b/rats-tls/src/tls_wrappers/openssl/un_negotiate.c
index abbdb60b5..f71ccc0d0 100644
--- a/rats-tls/src/tls_wrappers/openssl/un_negotiate.c
+++ b/rats-tls/src/tls_wrappers/openssl/un_negotiate.c
@@ -265,6 +265,7 @@ int verify_certificate(X509_STORE_CTX *ctx)
 int verify_certificate(int preverify, X509_STORE_CTX *ctx)
 {
 #endif
+#if !defined(OPENSSL_VERSION_NUMBER) || OPENSSL_VERSION_NUMBER < 0x10100000L
 	X509_STORE *cert_store = X509_STORE_CTX_get0_store(ctx);
 	int *ex_data = per_thread_getspecific();
 	if (!ex_data) {
@@ -278,6 +279,20 @@ int verify_certificate(int preverify, X509_STORE_CTX *ctx)
 		return 0;
 	}
 
+#else
+	X509_STORE *cert_store = X509_STORE_CTX_get0_store(ctx);
+	int *ex_data = per_thread_getspecific();
+	if (!ex_data) {
+		RTLS_ERR("failed to get ex_data\n");
+		return 0;
+	}
+
+	tls_wrapper_ctx_t *tls_ctx = X509_STORE_get_ex_data(cert_store, *ex_data);
+	if (!tls_ctx) {
+		RTLS_ERR("failed to get tls_wrapper_ctx pointer\n");
+		return 0;
+	}
+#endif
 	X509 *cert = X509_STORE_CTX_get_current_cert(ctx);
 	if (!cert) {
 		RTLS_ERR("failed to get cert from x509 context!\n");
diff --git a/rats-tls/src/tls_wrappers/openssl/use_cert.c b/rats-tls/src/tls_wrappers/openssl/use_cert.c
index 768295d05..13debf7aa 100644
--- a/rats-tls/src/tls_wrappers/openssl/use_cert.c
+++ b/rats-tls/src/tls_wrappers/openssl/use_cert.c
@@ -16,8 +16,7 @@ tls_wrapper_err_t openssl_tls_use_cert(tls_wrapper_ctx_t *ctx, rats_tls_cert_inf
 		return -TLS_WRAPPER_ERR_INVALID;
 
 	openssl_ctx_t *ssl_ctx = (openssl_ctx_t *)ctx->tls_private;
-	int ret = SSL_CTX_use_certificate_ASN1(ssl_ctx->sctx, cert_info->cert_len,
-					       cert_info->cert_buf);
+	int ret = SSL_CTX_use_certificate_ASN1(ssl_ctx->sctx, cert_info->cert_len, cert_info->cert_buf);
 	if (ret != SSL_SUCCESS) {
 		RTLS_ERR("failed to use certificate %d\n", ret);
 		return OPENSSL_ERR_CODE(ret);
diff --git a/rats-tls/src/tls_wrappers/openssl/x509_openssl10x.c b/rats-tls/src/tls_wrappers/openssl/x509_openssl10x.c
new file mode 100644
index 000000000..5df81d7ef
--- /dev/null
+++ b/rats-tls/src/tls_wrappers/openssl/x509_openssl10x.c
@@ -0,0 +1,38 @@
+/* Copyright (c) 2021 Intel Corporation
+ * Copyright (c) 2020-2021 Alibaba Cloud
+ *
+ * SPDX-License-Identifier: Apache-2.0
+ */
+
+#include <openssl/opensslv.h>
+#if !defined(OPENSSL_VERSION_NUMBER) || OPENSSL_VERSION_NUMBER < 0x10100000L
+
+#include <openssl/x509.h>
+#include <openssl/ssl.h>
+
+int X509_STORE_get_ex_new_index(long argl, void *argp, CRYPTO_EX_new *new_func, CRYPTO_EX_dup *dup_func, CRYPTO_EX_free *free_func)
+{
+    return CRYPTO_get_ex_new_index(CRYPTO_EX_INDEX_X509_STORE, argl, argp, new_func, dup_func, free_func);
+}
+
+const STACK_OF(X509_EXTENSION) *X509_get0_extensions(const X509 *x)
+{
+    return x->cert_info->extensions;
+}
+
+int X509_STORE_set_ex_data(X509_STORE *ctx, int idx, void *data)
+{
+    return CRYPTO_set_ex_data(&ctx->ex_data, idx, data);
+}
+
+void *X509_STORE_get_ex_data(const X509_STORE *ctx, int idx)
+{
+    return CRYPTO_get_ex_data(&ctx->ex_data, idx);
+}
+
+X509_STORE *X509_STORE_CTX_get0_store(X509_STORE_CTX *ctx)
+{
+    return ctx->ctx;
+}
+
+#endif
